/*
 * Copyright 2016 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.urmc;

import at.jku.risc.stout.urmc.algo.DebugLevel;
import at.jku.risc.stout.urmc.algo.MatchAlgorithm;
import at.jku.risc.stout.urmc.algo.MatchProblem;
import at.jku.risc.stout.urmc.algo.MatchSystem;
import at.jku.risc.stout.urmc.algo.Substitution;
import at.jku.risc.stout.urmc.data.InputParser;
import at.jku.risc.stout.urmc.data.atom.NodeFactory;

public class Test {

	public static void main(String[] args) {
		System.out.println("running tests...");
		testAll();
	}

	public static void testAll() {
		test("C(f(X)) << g(f(a,b),h(f(a),f))");
	}

	public static void test(String in) {
		try {
			MatchProblem p = new MatchProblem();
			new InputParser(p, new NodeFactory()).parseEqSystem(in, null);
			new MatchAlgorithm(new MatchSystem(p, new Substitution())).match(
					DebugLevel.PROGRESS, System.out, System.out, true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
