/*
 * Copyright 2016 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.urmc.data.atom;

import java.util.Map;

import at.jku.risc.stout.urmc.data.TermNode;

/**
 * A function variable can be substituted by a function symbol or function
 * variable.
 * 
 * @author Alexander Baumgartner
 */
public class FunctionVar extends Variable {
	FunctionVar(String name) {
		super(name);
	}

	@Override
	public TermNode substitute(Variable from, TermNode to, TermNode thisNode) {
		if (equals(from))
			thisNode.setAtom(to.getAtom());
		return thisNode;
	}

	@Override
	public TermNode apply(Map<Variable, TermNode> sigma, TermNode thisNode) {
		TermNode to = sigma.get(this);
		if (to != null)
			thisNode.setAtom(to.getAtom());
		return thisNode;
	}
}
